`timescale 1ns / 1ps
`include "parameters.v"

module test_gpio_read_pins_v;

	// Inputs
	reg clk;
	reg reset;
	reg [`GPIO_PINS-1:0]gpio_pins_in;
	reg [`GPIO_PINS-1:0]read_mask;
	reg [`GPIO_PINS-1:0]interrupt_mask;
	reg ready;

	// Outputs
	wire interrupt;
	wire [`REG_WIDTH-1:0]value_register_output;
	wire value_wen;

	// Instantiate the Unit Under Test (UUT)
	gpio_read_pins uut (
		.clk(clk), 
		.reset(reset), 
		.gpio_pins_in(gpio_pins_in), 
		.read_mask(read_mask), 
		.interrupt_mask(interrupt_mask), 
		.ready(ready), 
		.interrupt(interrupt), 
		.value_register_output(value_register_output), 
		.value_wen(value_wen)
	);

	initial begin
		// Initialize Inputs
		clk = 0;
		reset = 1;
		gpio_pins_in = 0;
		read_mask = 0;
		interrupt_mask = 0;
		ready = 0;

		// Wait 100 ns for global reset to finish
		#100;
        
		// Add stimulus here
		reset = 0;
		read_mask = 		16'b0101010101010101; // 5555
		interrupt_mask = 	16'b0000000001010101; // 0055
		
		#20;
		gpio_pins_in = 	16'b1101010010010100; // D494
		#20;
		gpio_pins_in = 	16'b1001010010010100; // 9494
		#20;
		
		ready = 1'b1;
		
		#20;
		gpio_pins_in = 	16'b1101010010010100; // D494
		#20;
		gpio_pins_in = 	16'b1001010010010100; // 9494
		#20;
		gpio_pins_in = 	16'b1001010010011111; // 949F
		#20;
		
		#250;
		
		#20;
		gpio_pins_in = 	16'b0001010010011111; // 149F
		#20;
		gpio_pins_in = 	16'b0101010010011111; // 549F
		#20;
		gpio_pins_in = 	16'b0101010010011110; // 549E
		#20;
	end
      
	always
	begin
		#5 clk = ~clk;
	end
endmodule

